var maskArray;
var isEscapeArray;

function anyMask(event, sMask) {

  //if not mask specified, treat as regular text box
  if (sMask == "null" || sMask.length == 0)
    return true;


  //set mask array; should be set once, 
  //however there could be multiple masked text fields in a give page
  var j = 0;
  maskArray = new Array();
  isEscapeArray = new Array();

  for (var i = 0; i < sMask.length; i++) {
    maskChar = sMask.charAt(i);

    if (maskChar == '\\') {
      if ((i+1) < sMask.length) {
        maskArray[j] = sMask.charAt(i+1);
        isEscapeArray[j] = 1;
        i = i + 1;
      }
    }
    else {
      maskArray[j] = maskChar;
      isEscapeArray[j] = 0;
    } 

    j++;      
  }


  var KeyTyped = String.fromCharCode(getKeyCode(event));
  var targ = getTarget(event);
  keyCount = targ.value.length;


  //Backspace or Delete key
  if (KeyTyped.charCodeAt(0) == 8 || KeyTyped.charCodeAt(0) == 127)
    return true;


  //if an escape character
  if (isEscapeArray[keyCount] == 1) {
    if ( (maskArray[keyCount] == '#' && KeyTyped == '#') ||
         (maskArray[keyCount] == 'A' && KeyTyped == 'A') ||
         (maskArray[keyCount] == 'a' && KeyTyped == 'a') ||
         (maskArray[keyCount] == 'B' && KeyTyped == 'B') ||
         (maskArray[keyCount] == '.' && KeyTyped == '.') ||
         (maskArray[keyCount] == '*' && KeyTyped == '*') ||
         (maskArray[keyCount] == '\\' && KeyTyped == '\\')) {
      return true;
    }
    else
      return false;
  }

  //key typed is same as mask char; except for those in the clause
  if (maskArray[keyCount] == KeyTyped &&
      KeyTyped != '#' &&
      KeyTyped != 'A' &&
      KeyTyped != 'a' &&
      KeyTyped != 'B' &&
      KeyTyped != '.' &&
      KeyTyped != '*') {
    return true;
  }


  //numbers 0 - 9
  if ((maskArray[keyCount] == '#') && isNumeric(KeyTyped)) {
    return true; 
  }


  //uppercase letters
  if ((maskArray[keyCount] == 'A') && isUpperCaseLetter(KeyTyped)) {
    return true; 
  }


  //lowercase letters
  if ((maskArray[keyCount] == 'a') && isLowerCaseLetter(KeyTyped)) {
    return true; 
  }


  //all letters (upper/lower)
  if ((maskArray[keyCount] == 'B') && isAnyCaseLetter(KeyTyped)) {
    return true; 
  }


  //any character
  if (maskArray[keyCount] == '.') {
    return true;
  }


  //any letter (upper/lower) or number
  if ((maskArray[keyCount] == '*') && isAlphaNumeric(KeyTyped)) {
    return true;
  }


  //everything less than the "space" char; except for carriage returns
  if (KeyTyped.charCodeAt(0) < 32 && (KeyTyped.charCodeAt(0) != 12 || KeyTyped.charCodeAt(0) != 13)) {
    return true;
  }
    

  return false;
}


function getTarget(e) {
  // IE5
  if (e.srcElement)
    return e.srcElement;

  if (e.target)
    return e.target;
}


function getKeyCode(e) {
  //IE5
  if (e.srcElement)
    return e.keyCode

  // NC5
  if (e.target)
    return e.which
}


function isNumeric(c) {
  var lCode = c.charCodeAt(0);

  if (lCode >= 48 && lCode <= 57)
    return true;
  else 
    return false;
}  


function isUpperCaseLetter(c) {
  var lCode = c.charCodeAt(0);

  if (lCode >= 65 && lCode <= 90)
    return true;
  else 
    return false;
}  


function isLowerCaseLetter(c) {
  var lCode = c.charCodeAt(0);

  if (lCode >= 97 && lCode <= 122)
    return true;
  else 
    return false;
}  


function isAnyCaseLetter(c) {
  return isLowerCaseLetter(c) || isUpperCaseLetter(c);
}


function isAlphaNumeric(c) {
  return isLowerCaseLetter(c) || isUpperCaseLetter(c) || isNumeric(c);
}
 
//  End -->
